package com.fjhx.sale.flow;

import com.alibaba.fastjson.JSONObject;
import com.fjhx.flow.core.FlowDelegate;
import com.fjhx.sale.entity.contract.dto.ContractDto;
import com.fjhx.sale.entity.contract.po.Contract;
import com.fjhx.sale.service.contract.ContractService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class SalesOutboundApprovedFlow extends FlowDelegate {
    @Autowired
    private ContractService contractService;

    @Override
    public String getFlowKey() {
        return "sales_outbound_approved_flow";
    }

    @Override
    public Long start(Long flowId, JSONObject submitData) {
        Long id = submitData.getLong("id");
        Contract contract = contractService.getById(id);
        //将code赋值给流程引擎
        submitData.put("code", contract.getCode());
        return id;
    }

    @Override
    public void end(Long flowId, Long businessId, JSONObject submitData) {
        ContractDto contractDto = submitData.toJavaObject(ContractDto.class);
        //特批无需校验金额
        contractDto.setSpecialOutbound(true);
        contractService.saleOutbound(contractDto);
    }
}
